﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "GOAPAction.h"

bool UGOAPAction::CheckPreConditions(TMap<FString, int> WorldState)
{
	for (TPair<FString, int> PreCondition : PreConditions)
	{
		if (WorldState.Contains(PreCondition.Key))
		{
			if (WorldState[PreCondition.Key] < PreCondition.Value) return false;
		}
	}
	return true;
}

TMap<FString, int> UGOAPAction::ApplyEffects(TMap<FString, int> WorldState)
{
	for (TPair<FString, int> Effect : Effects)
	{
		if (WorldState.Contains(Effect.Key))
		{
			WorldState[Effect.Key] -= Effect.Value;
		}
	}
	return WorldState;
}
